unit frmMain;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Menus, ComCtrls,
 ActnList, LCLIntf, LCLType, StdCtrls, Buttons;

type

 { TfMain }

 TfMain = class(TForm)
  acMain: TActionList;
  acOpenFile: TAction;
  acOpenDir: TAction;
  acEditor: TAction;
  acExport: TAction;
  btnOpenDir: TSpeedButton;
  btnOpenFile: TBitBtn;
  ilMain: TImageList;
  lblDeviceCaps: TLabel;
  lblFontDPI: TLabel;
  lblIconSize: TLabel;
  miEditor: TMenuItem;
  miExport: TMenuItem;
  miView: TMenuItem;
  miOpenDir: TMenuItem;
  miFile: TMenuItem;
  miOpenFile: TMenuItem;
  mMenu: TMainMenu;
  tbMain: TToolBar;
  tbOpenFile: TToolButton;
  tbOpenDir: TToolButton;
  tbEditor: TToolButton;
  tbExport: TToolButton;
  procedure acEditorExecute(Sender: TObject);
  procedure acOpenDirExecute(Sender: TObject);
  procedure acOpenFileExecute(Sender: TObject);
  procedure FormCreate(Sender: TObject);
 private
  PPI: Double;
 public

 end;

var
 fMain: TfMain;

implementation

{$R *.frm}

{ TfMain }

procedure TfMain.acOpenFileExecute(Sender: TObject);
begin
 lblFontDPI.Caption := Format('Font DPI: %d', [Font.PixelsPerInch]);
end;

procedure TfMain.FormCreate(Sender: TObject);
begin
 PPI := 96.0;
end;

procedure TfMain.acOpenDirExecute(Sender: TObject);
var
    DC: HDC;
    DevW, DevH, PixW, PixH, LX, LY: Integer;
    DevDiag, PixDiag: Real;
begin
 DC := GetDC(0);
 DevW := GetDeviceCaps(DC, HORZSIZE);
 DevH := GetDeviceCaps(DC, VERTSIZE);
 PixW := GetDeviceCaps(DC, HORZRES);
 PixH := GetDeviceCaps(DC, VERTRES);
 LX := GetDeviceCaps(DC, LOGPIXELSX);
 LY := GetDeviceCaps(DC, LOGPIXELSY);
 ReleaseDC(0, DC);
 DevDiag := (Sqrt((DevW*DevW) + (DevH*DevH))) / 25.4;
 PixDiag := Sqrt((PixW*PixW) + (PixH*PixH));
 PPI := PixDiag / DevDiag;
 lblDeviceCaps.Caption :=
     Format('Hor. size: %d [mm]' + LineEnding +
            'Ver. size: %d [mm]' + LineEnding +
            'Hor. pixels: %d' + LineEnding +
            'Hor. pixels: %d' + LineEnding +
            'Device diagonal: %f [inch]' + LineEnding +
            'Pixel diagonal: %f' + LineEnding +
            'DeviceCaps PPI: %d ppi' + LineEnding +
            'Logical X PPI: %d' + LineEnding +
            'Loagical Y PPI: %d',
            [DevW, DevH, PixW, PixH, DevDiag, PixDiag, Round(PPI), LX, LY]);

end;

procedure TfMain.acEditorExecute(Sender: TObject);
begin
 lblIconSize.Caption :=
     Format('Menu Icon width: %d' + LineEnding +
            'ImageList.ResolutionForPPI: %d' + LineEnding +
            'Font scaling MulDiv: %d',
            [miOpenFile.Bitmap.Width,
             {this procedure is used for draw the toolbutton icon}
             ilMain.ResolutionForPPI[tbMain.ImagesWidth, Font.PixelsPerInch, GetCanvasScaleFactor].Width,
             {this is used for the scaling the fonts}
             MulDiv(miOpenFile.Bitmap.Width, Font.PixelsPerInch, Round(PPI))]);
end;

end.

